<template>
  <div class="app-container">
    <el-button
      v-if="$attrs.optType === 'add'"
      type="primary"
      plain
      icon="el-icon-plus"
      size="mini"
      @click="$refs['ItemSelectRef'].showFlag = true"
    >{{ $t('common.add') }}</el-button>
    <ItemSelect ref="ItemSelectRef" @onSelected="onItemSelect" />
    <el-table v-loading="loading" :data="tmToolRequestItemList" @selection-change="handleSelectionChange">
      <!-- <el-table-column type="selection" width="55" align="center" /> -->
      <!-- <el-table-column label="主键id" align="center" prop="toolRequestItemId" />
      <el-table-column label="刀模版申请单id" align="center" prop="toolRequestId" /> -->
      <el-table-column :label="$t('刀模版物料名称')" align="center" prop="itemName" />

      <el-table-column width="120px" v-if="$attrs.optType === 'add'" :label="$t('数量')" align="center" prop="quantity" >
         <template slot-scope="scope">
            <el-input v-model="scope.row.quantity" @blur="$emit('sum')" />
         </template>
      </el-table-column>
      <el-table-column  width="120px" v-else :label="$t('数量')" align="center" prop="quantity" />
      <el-table-column  width="120px" :label="$t('预计使用寿命')" align="center" prop="estimatedLifeTime" />
      <el-table-column width="100px" v-if="$attrs.optType === 'add'" :label="$t('common.option')" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleRemove(scope.row, scope.$index)"
          >{{ $t('common.del') }}</el-button>
          </template>
        </el-table-column>
    </el-table>


    <pagination
      v-show="total>0&&$attrs.optType !== 'add'"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改刀模版物料申请单对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item :label="$t('刀模版申请单id')" prop="toolRequestId">
          <el-input v-model="form.toolRequestId" />
        </el-form-item>
        <el-form-item :label="$t('物料id')" prop="itemId">
          <el-input v-model="form.itemId" />
        </el-form-item>
        <el-form-item :label="$t('数量')" prop="allQuantity">
          <el-input v-model="form.allQuantity" />
        </el-form-item>
        <el-form-item :label="$t('预计使用寿命')" prop="nextMaintenPeriod">
          <el-input v-model="form.nextMaintenPeriod" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">{{ $t('common.confirm') }}</el-button>
        <el-button @click="cancel">{{ $t('common.cancel') }}</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>


import { listTmToolRequestItem, getTmToolRequestItem, delTmToolRequestItem, addTmToolRequestItem, updateTmToolRequestItem } from "@/api/mes/tm/tmToolRequestItem";
import { getTaskIdMaxProcessTool } from "@/api/mes/pro/protask";
import ItemSelect from "@/components/itemSelect/index.vue";
export default {
  name: "TmToolRequestItem",
  components: {ItemSelect},
  props:{
    toolRequestId:{
      type:String,
      default:''
    }
  },
  data() {
    return {
      // 遮罩层
      loading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 刀模版物料申请单表格数据
      tmToolRequestItemList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        toolRequestId: null,        itemId: null,        allQuantity: null,        nextMaintenPeriod: null,      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      },
      addList: [],
      detailList: []
    };
  },
  watch: {
     '$attrs.taskId'(newVal, oldVal){
      if (this.$attrs.optType === 'add') {
        this.getTaskList()
      }
     }
  },
  created() {
    if (this.$attrs.optType !== 'add') {
      this.getList();
    }
  },
  methods: {
    onItemSelect(list){
      // console.log(list, 'list')
      this.addList = list.map(item => {
        return {
          itemId:item.itemId,
          itemName:item.itemName,
          quantity: 1,
          estimatedLifeTime: Number(this.$attrs.quantity) || 0
        }
      })
      this.tmToolRequestItemList = this.detailList.concat(this.addList)
      this.$emit('sum')
    },
    /** 查询刀模版物料申请单列表 */
    getList() {
      this.loading = true;
      this.queryParams.toolRequestId = this.toolRequestId;
      listTmToolRequestItem(this.queryParams).then(response => {
        this.tmToolRequestItemList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 查询任务刀模版申请单列表 */
    getTaskList() {
      this.loading = true;
      this.queryParams.taskId = this.$attrs.taskId;
      this.queryParams.pageSize = 10000;
      getTaskIdMaxProcessTool(this.queryParams).then(response => {
        this.detailList = response.data.map(item => {
           return {
             ...item,
             allQuantity: Number(item.AllQuantity)
           }
        });
        this.addList = this.addList.map(item => {
          return {
            ...item,
            nextMaintenPeriod: Number(this.$attrs.quantity)
          }
        })
        this.tmToolRequestItemList = this.detailList.concat(this.addList)
        // this.total = response.total;
        this.loading = false;
        this.$emit('sum')
      });
    },
    handleRemove(row, index) {
      console.log(row,index)
      // this.tags.splice(this.tags.indexOf(tag), 1)
      this.tmToolRequestItemList.splice(this.tmToolRequestItemList.indexOf(row), 1)
      this.$emit('sum')
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        toolRequestItemId: null,        toolRequestId: null,        itemId: null,        allQuantity: null,        nextMaintenPeriod: null,        createBy: null,        createTime: null,        updateBy: null,        updateTime: null      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.toolRequestItemId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = this.$t('添加刀模版物料申请单');
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const toolRequestItemId = row.toolRequestItemId || this.ids
      getTmToolRequestItem(toolRequestItemId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = this.$t('修改刀模版物料申请单');
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.toolRequestItemId != null) {
            updateTmToolRequestItem(this.form).then(response => {
              this.$modal.msgSuccess(this.$t('common.edit_success'));
              this.open = false;
              this.getList();
            });
          } else {
            addTmToolRequestItem(this.form).then(response => {
              this.$modal.msgSuccess(this.$t('common.add_success'));
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const toolRequestItemIds = row.toolRequestItemId || this.ids;
      this.$modal.confirm(this.$t('common.confirm_del_data')).then(function() {
        return delTmToolRequestItem(toolRequestItemIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess(this.$t('common.del_success'));
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('tm/tmToolRequestItem/export', {
        ...this.queryParams
      }, `tmToolRequestItem_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
